diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/environment-variable.h ns-3.38/src/core/model/environment-variable.h
--- ns-3.37/src/core/model/environment-variable.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/model/environment-variable.h	2023-03-16 20:54:23.588868400 -0700
@@ -0,0 +1,232 @@
+/*
+ * Copyright (c) 2022 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#ifndef ENVIRONMENT_VARIABLE_H
+#define ENVIRONMENT_VARIABLE_H
+
+/**
+ * \file
+ * \ingroup core-environ
+ * Class Environment declaration.
+ */
+
+#include <memory> // shared_ptr
+#include <string>
+#include <unordered_map>
+#include <utility> // pair
+
+namespace ns3
+{
+
+/// \todo Reconsider the name?
+/// Rename to just EnvironmentVariableDictionary?
+/// System::EnvironmentVariable?
+
+// Forward declaration
+namespace tests
+{
+class EnvVarTestCase;
+}
+
+/**
+ * \ingroup core-environ
+ * Hold key,value dictionaries for environment variables.
+ *
+ * The environment variable can have multiple key,value pairs
+ * separated by a delimiter, which is ";" by default.
+ *
+ * Individual pairs are connected by '='.  As an extension a bare key
+ * will be assigned the empty string \c "".
+ *
+ * For example, `ENVVAR="key1=value1;key2;key3=value3"`.
+ */
+class EnvironmentVariable
+{
+  public:
+    /**
+     * Result of a key lookup.
+     * The \p first is \c true if the key was found.
+     *
+     * The \p second contains the value associated with the key.
+     */
+    using KeyFoundType = std::pair<bool, std::string>;
+
+    /**
+     * Get the value corresponding to a key from an environment variable.
+     *
+     * If the \p key is empty just return the environment variable,
+     * (or `{false, ""}` if the variable doesn't exist).
+     *
+     * If the \p key is not empty return the associated value
+     * (or `{false, ""}` if the key is not found).
+     * If the key is present but has no value return `{true, ""}`.
+     *
+     * Key-value pairs are separated by \p delim.  Individual keys and
+     * values are separated by an `=` sign. If the `=` is not present
+     * the value returned is the empty string.
+     *
+     * Notice that two cases both return `{false, ""}`:
+     * * The environment variable doesn't exist, or
+     * * It exists but the (non-empty) \p key wasn't found.
+     *
+     * Notice that two cases both return `{true, ""}`: the environment
+     * variable exists and
+     * * The \p key was empty and the environment variable was empty, or
+     * * The (not empty) key was found, but with no value.
+     *
+     * In practice neither of these ambiguities is important:
+     * * If the return contains \c false the key doesn't exist.
+     * * If the return contains \c true but the string is empty either the
+     *   (not empty) key exists with no value, or the key was empty and the
+     *   environment variable itself is empty.
+     *
+     * \param [in] envvar The environment variable.
+     * \param [in] key The key to extract from the environment variable.
+     * \param [in] delim The delimiter between key,value pairs.
+     * \returns Whether the key was found, and its value, as explained above.
+     */
+    static KeyFoundType Get(const std::string& envvar,
+                            const std::string& key = "",
+                            const std::string& delim = ";");
+
+    // Forward
+    class Dictionary;
+
+    /**
+     * Get the dictionary for a particular environment variable.
+     *
+     * This should be used when one needs to process all key,value
+     * pairs, perhaps without knowing the set of possible keys.
+     *
+     * \param [in] envvar The environment variable.
+     * \param [in] delim The delimiter between key,value pairs.
+     * \returns The Dictionary.
+     */
+    static std::shared_ptr<Dictionary> GetDictionary(const std::string& envvar,
+                                                     const std::string& delim = ";");
+
+    /** Key, value dictionary for a single environment variable. */
+    class Dictionary
+    {
+      public:
+        /**
+         * Constructor.
+         *
+         * Parse an environment variable containing keys and optional values.
+         *
+         * Keys in the environment variable are separated by the
+         * \p delim character.  Keys may be assigned values by following
+         * the key with the `=` character; any remaining text up to the next
+         * delimiter will be taken as the value.  If no `=`
+         * is given the enpty string will be stored as the value.
+         *
+         * \param [in] envvar The environment variable.
+         * \param [in] delim The delimiter between key,value pairs.
+         */
+        Dictionary(const std::string& envvar, const std::string& delim = ";");
+
+        /**
+         * Get the value corresponding to a key from this dictionary.
+         * If the \p key is empty return the full environment variable value.
+         * \param [in] key The key to extract from the environment variable.
+         * \returns \c true if the key was found, and the associated value.
+         */
+        KeyFoundType Get(const std::string& key = "") const;
+
+        /** Key, value store type. */
+        using KeyValueStore = std::unordered_map<std::string, std::string>;
+
+        /** Get the underlying store, for iterating.
+         * \returns The key, value store.
+         */
+        KeyValueStore GetStore() const;
+
+      private:
+        /** Whether the environment variable exists in the environment. */
+        bool m_exists;
+        /** The raw environment variable. */
+        std::string m_variable;
+        /** The key, value store. */
+        KeyValueStore m_dict;
+
+    }; // class Dictionary
+
+    /**
+     * Set an environment variable.
+     *
+     * To set a variable to the empty string use `Set(variable, "")`.
+     * Note: empty environment variables are not portable (unsupported on Windows).
+     *
+     * \param [in] variable The environment variable to set.  Note this may not contain the `=`
+     * character. \param [in] value The value to set.  Note this must not be an empty string on
+     * Windows. \returns \c true if the variable was set successfully
+     */
+    static bool Set(const std::string& variable, const std::string& value);
+
+    /**
+     * Unset an environment variable.
+     * This removes the variable from the environment.
+     * To set a variable to the empty string use `Set(variable, "")`.
+     *
+     * \param [in] variable The environment variable to unset.  Note this may not contain the `=`
+     * character. \returns \c true if the variable was unset successfully.
+     */
+    static bool Unset(const std::string& variable);
+
+    /**
+     * \name Singleton
+     *
+     * This class is a singleton, accessed by static member functions,
+     * so the Rule of Five functions are all deleted.
+     */
+    /** @{ */
+    EnvironmentVariable() = delete;
+    EnvironmentVariable(const EnvironmentVariable&) = delete;
+    EnvironmentVariable& operator=(const EnvironmentVariable&) = delete;
+    EnvironmentVariable(EnvironmentVariable&&) = delete;
+    EnvironmentVariable& operator=(EnvironmentVariable&&) = delete;
+    /** @} */
+
+  private:
+    /**
+     * How Dictionaries are stored.
+     *
+     * \p key: the environment variable name
+     *
+     * \p Dictionary: the parsed Dictionary for the \p key
+     */
+    using DictionaryList = std::unordered_map<std::string, std::shared_ptr<Dictionary>>;
+
+    /**
+     * Access the DictionaryStore instance.
+     * \returns the DictionaryStore.
+     */
+    static DictionaryList& Instance();
+
+    // Test needs to clear the instance
+    friend class tests::EnvVarTestCase;
+
+    /** Clear the instance, forcing all new lookups. */
+    static void Clear();
+
+}; // class EnvironmentVariable
+
+} // namespace ns3
+
+#endif /* ENVIRONMENT_VARIABLE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/example-as-test.cc ns-3.38/src/core/model/example-as-test.cc
--- ns-3.37/src/core/model/example-as-test.cc	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/example-as-test.cc	2023-03-16 20:54:23.588868400 -0700
@@ -21,9 +21,11 @@
 
 #include "ascii-test.h"
 #include "assert.h"
+#include "environment-variable.h"
+#include "fatal-error.h"
 #include "log.h"
 
-#include <cstdlib> // itoa(), system (), getenv ()
+#include <cstdlib> // itoa(), system ()
 #include <cstring>
 #include <sstream>
 #include <string>
@@ -45,11 +47,13 @@
 ExampleAsTestCase::ExampleAsTestCase(const std::string name,
                                      const std::string program,
                                      const std::string dataDir,
-                                     const std::string args /* = "" */)
+                                     const std::string args /* = "" */,
+                                     const bool shouldNotErr /* = true */)
     : TestCase(name),
       m_program(program),
       m_dataDir(dataDir),
-      m_args(args)
+      m_args(args),
+      m_shouldNotErr(shouldNotErr)
 {
     NS_LOG_FUNCTION(this << name << program << dataDir << args);
 }
@@ -84,42 +88,59 @@
     SetDataDir(m_dataDir);
     std::string refFile = CreateDataDirFilename(GetName() + ".reflog");
     std::string testFile = CreateTempDirFilename(GetName() + ".reflog");
+    std::string post = GetPostProcessingCommand();
+
+    if (!m_shouldNotErr)
+    {
+        // Strip any system- or compiler-dependent messages
+        // resulting from invoking NS_FATAL..., which in turn
+        // calls std::terminate
+        post += " | sed '1,/" + std::string(NS_FATAL_MSG) + "/!d' ";
+    }
 
     std::stringstream ss;
 
     ss << "python3 ./ns3 run " << m_program << " --no-build --command-template=\""
-       << GetCommandTemplate()
-       << "\""
+       << GetCommandTemplate() << "\"";
 
-       // redirect std::clog, std::cerr to std::cout
-       << " 2>&1 "
-       // Suppress the waf lines from output; waf output contains directory paths which will
-       // obviously differ during a test run
-       << " " << GetPostProcessingCommand() << " > " << testFile;
+    if (post.empty())
+    {
+        // redirect to testfile, then std::clog, std::cerr to std::cout
+        ss << " > " << testFile << " 2>&1";
+    }
+    else
+    {
+        ss << " 2>&1 " << post << " > " << testFile;
+    }
 
     int status = std::system(ss.str().c_str());
 
-    std::cout << "command:  " << ss.str() << "\n"
-              << "status:   " << status << "\n"
-              << "refFile:  " << refFile << "\n"
-              << "testFile: " << testFile << "\n"
-              << std::endl;
-    std::cout << "testFile contents:" << std::endl;
+    std::cout << "\n"
+              << GetName() << ":\n"
+              << "    command:  " << ss.str() << "\n"
+              << "    status:   " << status << "\n"
+              << "    refFile:  " << refFile << "\n"
+              << "    testFile: " << testFile << "\n"
+              << "    testFile contents:" << std::endl;
 
     std::ifstream logF(testFile);
     std::string line;
     while (getline(logF, line))
     {
-        std::cout << line << "\n";
+        std::cout << "--- " << line << "\n";
     }
     logF.close();
 
-    // Make sure the example didn't outright crash
-    NS_TEST_ASSERT_MSG_EQ(status, 0, "example " + m_program + " failed");
+    if (m_shouldNotErr)
+    {
+        // Make sure the example didn't outright crash
+        NS_TEST_ASSERT_MSG_EQ(status, 0, "example " + m_program + " failed");
+    }
 
-    // Check that we're not just introspecting the command-line
-    const char* envVar = std::getenv("NS_COMMANDLINE_INTROSPECTION");
-    if (envVar != nullptr && std::strlen(envVar) != 0)
+    // If we're just introspecting the command-line
+    // we've run the example and we're done
+    auto [found, intro] = EnvironmentVariable::Get("NS_COMMANDLINE_INTROSPECTION");
+    if (found)
     {
         return;
     }
@@ -132,11 +153,12 @@
                                        const std::string program,
                                        const std::string dataDir,
                                        const std::string args /* = "" */,
-                                       const TestDuration duration /* =QUICK */)
+                                       const TestDuration duration /* =QUICK */,
+                                       const bool shouldNotErr /* = true */)
     : TestSuite(name, EXAMPLE)
 {
-    NS_LOG_FUNCTION(this << name << program << dataDir << args << duration);
-    AddTestCase(new ExampleAsTestCase(name, program, dataDir, args), duration);
+    NS_LOG_FUNCTION(this << name << program << dataDir << args << duration << shouldNotErr);
+    AddTestCase(new ExampleAsTestCase(name, program, dataDir, args, shouldNotErr), duration);
 }
 
 #endif // NS3_ENABLE_EXAMPLES
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/example-as-test.h ns-3.38/src/core/model/example-as-test.h
--- ns-3.37/src/core/model/example-as-test.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/example-as-test.h	2023-03-16 20:54:23.588868400 -0700
@@ -39,8 +39,8 @@
  * Execute an example program as a test, by comparing the output
  * to a reference file.
  *
- * User can subclass and override the GetCommandTemplate and
- * GetPostProcessingCommand methods if more complex
+ * User can subclass and override the GetCommandTemplate() and
+ * GetPostProcessingCommand() methods if more complex
  * example invocation patterns are required.
  *
  * \see examples-as-tests-test-suite.cc
@@ -64,11 +64,17 @@
      *                  `test-runner` the reference file will be created
      *                  with the correct name.
      * \param [in] args Any additional arguments to the program.
+     * \param [in] shouldNotErr Whether an error return status should be
+     *             considered a test failure. This is useful when testing
+     *             error detection which might return a non-zero status.
+     *             The output (on `std::cout` and `std::cerr`) will
+     *             be compared to the reference logs as normal.
      */
     ExampleAsTestCase(const std::string name,
                       const std::string program,
                       const std::string dataDir,
-                      const std::string args = "");
+                      const std::string args = "",
+                      const bool shouldNotErr = true);
 
     /** Destructor. */
     ~ExampleAsTestCase() override;
@@ -84,9 +90,15 @@
     /**
      * Customization point for tests requiring post-processing of stdout.
      *
-     * For example to sort return "| sort"
+     * For example to sort return `"| sort"`
      *
-     * Default is "", no processing step.
+     * One common case is to mask memory addresses, which can change
+     * when things are built on different platforms, recompiled locally,
+     * or even from run to run.  A simple post-processing filter could be
+     *
+     *    `"| sed -E 's/0x[0-9a-fA-F]{8,}/0x-address/g'"`
+     *
+     * Default is `""`, no additional processing.
      *
      * \returns The string of post-processing commands
      */
@@ -99,6 +111,7 @@
     std::string m_program; /**< The program to run. */
     std::string m_dataDir; /**< The source directory for the test. */
     std::string m_args;    /**< Any additional arguments to the program. */
+    bool m_shouldNotErr;   /**< Whether error return status is a test failure. */
 
 }; // class ExampleAsTestCase
 
@@ -135,12 +148,13 @@
  * which looks like this:
  *
  * \code{.cpp}
- * #include "ns3/example-as-test.h"
- * static ns3::ExampleAsTestSuite g_modExampleOne ("mymodule-example-mod-example-one",
- * "mod-example", NS_TEST_SOURCEDIR, "--arg-one"); static ns3::ExampleAsTestSuite g_modExampleTwo
- * ("mymodule-example-mod-example-two", "mod-example", NS_TEST_SOURCEDIR, "--arg-two"); \endcode
+ *     #include "ns3/example-as-test.h"
+ *     static ns3::ExampleAsTestSuite g_modExampleOne("mymodule-example-mod-example-one",
+ *         "mod-example", NS_TEST_SOURCEDIR, "--arg-one");
+ *     static ns3::ExampleAsTestSuite g_modExampleTwo("mymodule-example-mod-example-two",
+ *         "mod-example", NS_TEST_SOURCEDIR, "--arg-two"); \endcode
  *
- * The arguments to the constructor is the name of the test suite, the
+ * The arguments to the constructor are the name of the test suite, the
  * example to run, the directory that contains the "good" reference file
  * (the macro `NS_TEST_SOURCEDIR` is normally the correct directory),
  * and command line arguments for the example.  In the preceding code
@@ -204,7 +218,8 @@
                        const std::string program,
                        const std::string dataDir,
                        const std::string args = "",
-                       const TestDuration duration = QUICK);
+                       const TestDuration duration = QUICK,
+                       const bool shouldNotErr = true);
 }; // class ExampleAsTestSuite
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/global-value.cc ns-3.38/src/core/model/global-value.cc
--- ns-3.37/src/core/model/global-value.cc	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/global-value.cc	2023-03-16 20:54:23.588868400 -0700
@@ -19,6 +19,7 @@
 #include "global-value.h"
 
 #include "attribute.h"
+#include "environment-variable.h"
 #include "fatal-error.h"
 #include "log.h"
 #include "string.h"
@@ -26,9 +27,6 @@
 
 #include "ns3/core-config.h"
 
-#include <cstdlib> // getenv
-#include <cstring> // strlen
-
 /**
  * \file
  * \ingroup core
@@ -70,35 +68,15 @@
 {
     NS_LOG_FUNCTION(this);
 
-    const char* envVar = getenv("NS_GLOBAL_VALUE");
-    if (envVar == nullptr || std::strlen(envVar) == 0)
+    auto [found, value] = EnvironmentVariable::Get("NS_GLOBAL_VALUE", m_name);
+    if (found)
     {
-        return;
-    }
-    std::string env = envVar;
-    std::string::size_type cur = 0;
-    std::string::size_type next = 0;
-    while (next != std::string::npos)
-    {
-        next = env.find(';', cur);
-        std::string tmp = std::string(env, cur, next - cur);
-        std::string::size_type equal = tmp.find('=');
-        if (equal != std::string::npos)
+        Ptr<AttributeValue> v = m_checker->CreateValidValue(StringValue(value));
+        if (v)
         {
-            std::string name = tmp.substr(0, equal);
-            std::string value = tmp.substr(equal + 1, tmp.size() - equal - 1);
-            if (name == m_name)
-            {
-                Ptr<AttributeValue> v = m_checker->CreateValidValue(StringValue(value));
-                if (v)
-                {
-                    m_initialValue = v;
-                    m_currentValue = v;
-                }
-                return;
-            }
+            m_initialValue = v;
+            m_currentValue = v;
         }
-        cur = next + 1;
     }
 }
 
@@ -171,7 +149,7 @@
             return;
         }
     }
-    NS_FATAL_ERROR("Non-existant global value: " << name);
+    NS_FATAL_ERROR("Non-existent global value: " << name);
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/hash-fnv.h ns-3.38/src/core/model/hash-fnv.h
--- ns-3.37/src/core/model/hash-fnv.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/hash-fnv.h	2023-03-16 20:54:23.588868400 -0700
@@ -98,7 +98,7 @@
     /**
      * Seed value
      */
-    enum seed
+    enum Seed
     {
         SEED = 0x8BADF00D /**< Ate bad food */
     };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/hash-murmur3.h ns-3.38/src/core/model/hash-murmur3.h
--- ns-3.37/src/core/model/hash-murmur3.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/hash-murmur3.h	2023-03-16 20:54:23.592868600 -0700
@@ -101,7 +101,7 @@
      * This has to be a constant for all MPI ranks to generate
      * the same hash from the same string.
      */
-    enum seed
+    enum Seed
     {
         SEED = 0x8BADF00D // Ate bad food
     };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/int64x64-cairo.h ns-3.38/src/core/model/int64x64-cairo.h
--- ns-3.37/src/core/model/int64x64-cairo.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/int64x64-cairo.h	2023-03-16 20:54:23.592868600 -0700
@@ -296,7 +296,7 @@
     /**
      * Compute the inverse of an integer value.
      *
-     * Ordinary division by an integer would be limited to 64 bits of precsion.
+     * Ordinary division by an integer would be limited to 64 bits of precision.
      * Instead, we multiply by the 128-bit inverse of the divisor.
      * This function computes the inverse to 128-bit precision.
      * MulByInvert() then completes the division.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/int64x64-double.h ns-3.38/src/core/model/int64x64-double.h
--- ns-3.37/src/core/model/int64x64-double.h	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/int64x64-double.h	2023-03-16 20:54:23.592868600 -0700
@@ -314,7 +314,7 @@
      * \name Arithmetic Operators
      * Arithmetic operators for int64x64_t.
      */
-    /*
+    /**
      * @{
      * Arithmetic operator.
      * \param [in] lhs Left hand argument
@@ -367,7 +367,7 @@
      * \name Unary Operators
      * Unary operators for int64x64_t.
      */
-    /*
+    /**
      * @{
      * Unary operator.
      * \param [in] lhs Left hand argument
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/length.cc ns-3.38/src/core/model/length.cc
--- ns-3.37/src/core/model/length.cc	2022-11-01 17:37:24.467395000 -0700
+++ ns-3.38/src/core/model/length.cc	2023-03-16 20:54:23.592868600 -0700
@@ -181,7 +181,8 @@
         {{Unit::Yard, Unit::Meter}, USToMeter<std::ratio<3, 1>>},
         {{Unit::Meter, Unit::Yard}, MeterToUS<std::ratio<1, 3>>},
         {{Unit::Mile, Unit::Meter}, USToMeter<std::ratio<5280, 1>>},
-        {{Unit::Meter, Unit::Mile}, MeterToUS<std::ratio<1, 5280>>}};
+        {{Unit::Meter, Unit::Mile}, MeterToUS<std::ratio<1, 5280>>},
+    };
 
     auto iter = CONVERSIONS.find(Key{fromUnit, toUnit});
 
@@ -514,17 +515,19 @@
 {
     using StringTable = std::unordered_map<Length::Unit, std::string, EnumHash>;
 
-    static const StringTable STRINGS{{Length::Unit::Nanometer, "nm"},
-                                     {Length::Unit::Micrometer, "um"},
-                                     {Length::Unit::Millimeter, "mm"},
-                                     {Length::Unit::Centimeter, "cm"},
-                                     {Length::Unit::Meter, "m"},
-                                     {Length::Unit::Kilometer, "km"},
-                                     {Length::Unit::NauticalMile, "nmi"},
-                                     {Length::Unit::Inch, "in"},
-                                     {Length::Unit::Foot, "ft"},
-                                     {Length::Unit::Yard, "yd"},
-                                     {Length::Unit::Mile, "mi"}};
+    static const StringTable STRINGS{
+        {Length::Unit::Nanometer, "nm"},
+        {Length::Unit::Micrometer, "um"},
+        {Length::Unit::Millimeter, "mm"},
+        {Length::Unit::Centimeter, "cm"},
+        {Length::Unit::Meter, "m"},
+        {Length::Unit::Kilometer, "km"},
+        {Length::Unit::NauticalMile, "nmi"},
+        {Length::Unit::Inch, "in"},
+        {Length::Unit::Foot, "ft"},
+        {Length::Unit::Yard, "yd"},
+        {Length::Unit::Mile, "mi"},
+    };
 
     auto iter = STRINGS.find(unit);
 
@@ -554,7 +557,8 @@
         {Length::Unit::Inch, Entry{"inch", "inches"}},
         {Length::Unit::Foot, Entry{"foot", "feet"}},
         {Length::Unit::Yard, Entry{"yard", "yards"}},
-        {Length::Unit::Mile, Entry{"mile", "miles"}}};
+        {Length::Unit::Mile, Entry{"mile", "miles"}},
+    };
 
     auto iter = STRINGS.find(unit);
 
@@ -577,51 +581,53 @@
 {
     using UnitTable = std::unordered_map<std::string, Length::Unit>;
 
-    static const UnitTable UNITS{{"nm", Length::Unit::Nanometer},
-                                 {"nanometer", Length::Unit::Nanometer},
-                                 {"nanometers", Length::Unit::Nanometer},
-                                 {"nanometre", Length::Unit::Nanometer},
-                                 {"nanometres", Length::Unit::Nanometer},
-                                 {"um", Length::Unit::Micrometer},
-                                 {"micrometer", Length::Unit::Micrometer},
-                                 {"micrometers", Length::Unit::Micrometer},
-                                 {"micrometre", Length::Unit::Micrometer},
-                                 {"micrometres", Length::Unit::Micrometer},
-                                 {"mm", Length::Unit::Millimeter},
-                                 {"millimeter", Length::Unit::Millimeter},
-                                 {"millimeters", Length::Unit::Millimeter},
-                                 {"millimetre", Length::Unit::Millimeter},
-                                 {"millimetres", Length::Unit::Millimeter},
-                                 {"cm", Length::Unit::Centimeter},
-                                 {"centimeter", Length::Unit::Centimeter},
-                                 {"centimeters", Length::Unit::Centimeter},
-                                 {"centimetre", Length::Unit::Centimeter},
-                                 {"centimetres", Length::Unit::Centimeter},
-                                 {"m", Length::Unit::Meter},
-                                 {"meter", Length::Unit::Meter},
-                                 {"metre", Length::Unit::Meter},
-                                 {"meters", Length::Unit::Meter},
-                                 {"metres", Length::Unit::Meter},
-                                 {"km", Length::Unit::Kilometer},
-                                 {"kilometer", Length::Unit::Kilometer},
-                                 {"kilometers", Length::Unit::Kilometer},
-                                 {"kilometre", Length::Unit::Kilometer},
-                                 {"kilometres", Length::Unit::Kilometer},
-                                 {"nmi", Length::Unit::NauticalMile},
-                                 {"nauticalmile", Length::Unit::NauticalMile},
-                                 {"nauticalmiles", Length::Unit::NauticalMile},
-                                 {"in", Length::Unit::Inch},
-                                 {"inch", Length::Unit::Inch},
-                                 {"inches", Length::Unit::Inch},
-                                 {"ft", Length::Unit::Foot},
-                                 {"foot", Length::Unit::Foot},
-                                 {"feet", Length::Unit::Foot},
-                                 {"yd", Length::Unit::Yard},
-                                 {"yard", Length::Unit::Yard},
-                                 {"yards", Length::Unit::Yard},
-                                 {"mi", Length::Unit::Mile},
-                                 {"mile", Length::Unit::Mile},
-                                 {"miles", Length::Unit::Mile}};
+    static const UnitTable UNITS{
+        {"nm", Length::Unit::Nanometer},
+        {"nanometer", Length::Unit::Nanometer},
+        {"nanometers", Length::Unit::Nanometer},
+        {"nanometre", Length::Unit::Nanometer},
+        {"nanometres", Length::Unit::Nanometer},
+        {"um", Length::Unit::Micrometer},
+        {"micrometer", Length::Unit::Micrometer},
+        {"micrometers", Length::Unit::Micrometer},
+        {"micrometre", Length::Unit::Micrometer},
+        {"micrometres", Length::Unit::Micrometer},
+        {"mm", Length::Unit::Millimeter},
+        {"millimeter", Length::Unit::Millimeter},
+        {"millimeters", Length::Unit::Millimeter},
+        {"millimetre", Length::Unit::Millimeter},
+        {"millimetres", Length::Unit::Millimeter},
+        {"cm", Length::Unit::Centimeter},
+        {"centimeter", Length::Unit::Centimeter},
+        {"centimeters", Length::Unit::Centimeter},
+        {"centimetre", Length::Unit::Centimeter},
+        {"centimetres", Length::Unit::Centimeter},
+        {"m", Length::Unit::Meter},
+        {"meter", Length::Unit::Meter},
+        {"metre", Length::Unit::Meter},
+        {"meters", Length::Unit::Meter},
+        {"metres", Length::Unit::Meter},
+        {"km", Length::Unit::Kilometer},
+        {"kilometer", Length::Unit::Kilometer},
+        {"kilometers", Length::Unit::Kilometer},
+        {"kilometre", Length::Unit::Kilometer},
+        {"kilometres", Length::Unit::Kilometer},
+        {"nmi", Length::Unit::NauticalMile},
+        {"nauticalmile", Length::Unit::NauticalMile},
+        {"nauticalmiles", Length::Unit::NauticalMile},
+        {"in", Length::Unit::Inch},
+        {"inch", Length::Unit::Inch},
+        {"inches", Length::Unit::Inch},
+        {"ft", Length::Unit::Foot},
+        {"foot", Length::Unit::Foot},
+        {"feet", Length::Unit::Foot},
+        {"yd", Length::Unit::Yard},
+        {"yard", Length::Unit::Yard},
+        {"yards", Length::Unit::Yard},
+        {"mi", Length::Unit::Mile},
+        {"mile", Length::Unit::Mile},
+        {"miles", Length::Unit::Mile},
+    };
 
     // function to trim whitespace and convert to lowercase in one pass
     static auto Normalize = [](const std::string& str) {
@@ -843,6 +849,4 @@
     return Length(value, Length::Unit::Mile);
 }
 
-/**@}*/
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/length.h ns-3.38/src/core/model/length.h
--- ns-3.37/src/core/model/length.h	2022-11-01 17:37:24.471395000 -0700
+++ ns-3.38/src/core/model/length.h	2023-03-16 20:54:23.592868600 -0700
@@ -134,7 +134,7 @@
  * Length::Unit
  *
  * \code
- *   //These two contructors are equivalent
+ *   //These two constructors are equivalent
  *   Length l1 (1, "cm");
  *   Length l2 (1, Length::Unit::Centimeter);
  * \endcode
@@ -146,7 +146,7 @@
  * from boost::unit quantities.
  *
  * \code
- *   //construct length from a boost::units quantitiy
+ *   //construct length from a boost::units quantity
  *   boost::units::quantity<boost::units::si::length> q
  *       = 5 * boost::units::si::meter;
  *   Length meters (q);
@@ -445,7 +445,7 @@
      * Initialize an object with the value from \p other.
      *
      * After the move completes, \p other is left in an undefined but
-     * useable state.
+     * usable state.
      *
      * \param other Length object to move
      */
